/* Passive CF model */

#ifndef Cell_PASSIVECF_H
#define Cell_MASSIVECF_H

#include "StcCell.h"

#ifdef __cplusplus

	extern "C" {
#endif

// variables and constants
typedef struct {
	TypeCellML V_f;
	TypeCellML E_rev;
	TypeCellML I_total, I_pass; // currents
	TypeCellML I_stim, I_gap; // stimulation and diffusion current
} PassiveIVCF_State;

typedef struct {
	TypeCellML C_m;
	TypeCellML g_Pass; // I_K1
} PassiveIVCF_Const;

typedef union {
	TypeCellML *pDouble;
	PassiveIVCF_State *pState;
	PassiveIVCF_Const *pConst;
} PassiveIVCF_union;

StcCell *prototype_Cell_PassiveIVCF(void);
int alloc_Cell_PassiveIVCF_device(StcCell *pStcCell);
void init_Cell_PassiveIVCF_host(TypeCellML *pState, TypeCellML *pConst, int num);
void init_Cell_PassiveIVCF_device(StcCell *pStcCell);
void iter_Cell_PassiveIVCF(StcCell *pStcCell, TypeCellML deltaT);


#ifdef __cplusplus
}
#endif


#endif // define CellML_SachseCF_H
