; Simulation Acquisition Widget
; Bum-Rak Choi
; 2014

PRO ClsSimulAcq__DEFINE
	STRUCT = { ClsSimulAcq, $
				sIsOpen:0, $
				;oData:OBJ_NEW(), $
				oSimul:OBJ_NEW(), $
				sMonitor:0, $
				sAcquire:0, $
				sStim:0, $
				sDisplay:0, $
				iDelay:0L, $
				iDelayLeft:0L, $
				iAcquireLeft:0L, $
				;sTrigger:0, $
				sStimComments:0, $
				sCamera:0, $ ; visualize up to 3 variables
				sAutoSave:0, $
				fileTiming:'', $
				fileAdunit:'', $
				sAutoStimArr:INTARR(2), $
				sBatch: 0, $
				wBatch: 0L, $
				strComments:' ', $
				wTop:0L, $
				wDraw:LONARR(3), $
				wTrace:0L, $
				iChannelInd:0L, $
				wDrawStimulation:0L, $
				wFdCamera:LONARR(3), $
				wFdStimLogic:0L, $
				wBtStart:0L, $
				wMonitor:0L, $ ; monitor update widget
				wWait:0L, $
				wStrAutoStim:0L, $
				wFdStrComments:0L, $
				iDrawSize:[0L, 0L], $
				iChnXY:[0L,0L], $
				iNumChnsCam:0L, $
				iNumAuxChns:0L, $
				iNumFrames:0L, $
				fExposureTime:0.0, $
				iDisplaySkip:0L, $
				iDisplayType:LONARR(3), $ ; 0: Range, 1:Norm
				fRange:FLTARR(2,3), $
				iNumCam:0L, $
				iCamInd: LONARR(3,2), $
				iTraceInd: 0L, $
				wFdTraceInd: 0L, $
				pstrDisplay:PTR_NEW(), $
				pstrActions:PTR_NEW(), $
				sStimAutoRed:0, $
				sStimAutoAdj:0, $
				sStimAutoRedStep:0, $
				; strInitiationRoutine:'', $
				;sCapture:0, $
				strFilePath:'', $
				strFileTemplate:'', $
				strInitializeRoutine:'', $
				iFileScanNum:0L, $
				wFdFileScanNum:0L, $
				oMsg:OBJ_NEW() $
			}
END

PRO ClsSimulAcq::initObj
COMMON CM_SIMUL_ACQ, cmTraceBuffer, imgCam0, imgCam1, imgCam2
	str = ['Monitor', 'StimMonitor', 'StopMonitor', 'TIF', 'LoadCells', 'SaveCells',  $
			'StartStim', $ 
			;'StartStimCont', 
			'StopStim', 'Acquire','StimAcquire',$
			;'StartBatch', 'StopBatch', 
			'Abort', 'SaveBuffer', 'ShowCellTypes', 'UnloadDll','UpdateStructure','ChangegNaFactor','Close']
	self.pstrActions = PTR_NEW(str)
	str = ['Range', 'Norm']
	self.pstrDisplay = PTR_NEW(str)
	self.iNumFrames = 400L
	self.iChnXY = [125L,125L]
	self.iDrawSize = [250L, 250L] ; self.iChnXY * 2
	self.iNumChnsCam = self.iChnXY[0] * self.iChnXY[1]
	self.iNumAuxChns = 4L
	self.fExposureTime = 0.5
	self.iDisplaySkip = 5
	self.sCamera = 1
	self.iCamInd = [[0, 64, 97], [1, 3, 3]]
	self.fRange[*,0] = [-90.0, 50.0]
	self.fRange[*,1] = [0, 100]
	self.fRange[*,2] = [-100., 100.]
	; stimulation
	self.oMsg = OBJ_NEW('ClsMsgBox')
	self.sAutoSave = 0
	self.sStimAutoRedStep = 5 ; 5 ms reduction
	;self.strAutoStim = '350  200'
	self.sAutoStimArr = [350, 200]
	self.strComments = 'S1S1 Protocol'
	; simulation part
	;self.oSimul = OBJ_NEW('ClsRCMCuda')
	;self.oSimul->initObj
	;o->setValue, 'StimLogic', 'S10.2000.2'
	self.strFileTemplate = 'Simul-001-'
	self.strFilePath = 'd:\'
END

PRO ClsSimulAcq::initSimulObj
  IF OBJ_VALID(self.oSimul) THEN OBJ_DESTROY, self.oSimul
  ; self.iChnXY = [100, 100]
  self.oSimul = OBJ_NEW('ClsMultiCellCuda')
  self.oSimul->initObj
  o = self.oSimul
  ;o->initCMCF3D_OnDevice
  ;o->initCMOnly2DLindear_onDevice
  ;o->initCMCFmiddle2DLinear_OnDevice
  o->initCMCF3DTube_OnDevice
  o->getValue, 'DimXY', dimXY
  self.iChnXY = dimXY
  self.iDrawSize = [250L, 250L] ; self.iChnXY * 2
  self.iNumChnsCam = self.iChnXY[0] * self.iChnXY[1]
  o->setValue, 'StimLogic', 'S1.50.2 S10.400.2 S1.300.2'
  o->setValue, 'BuffSize', self.iNumFrames
  o->setValue, 'BuffDim', self.sCamera
  o->setValue, 'Diffusion', 1
  o->setValue, 'CudaBlockSize', 256L
END

PRO ClsSimulAcq::update, opt
  CASE opt OF
      'Diffusion':self.oSimul->updateDiffusion
  ENDCASE
END

PRO ClsSimulAcq::initMsgBox, widId, lines
	self.oMsg->initObj, widId, lines
END

PRO ClsSimulAcq::CLEANUP
COMMON CM_SIMUL_ACQ
	 cmTraceBuffer = 0
	 imgCam0 = 0
	 imgCam1 = 0
	 imgCam2 = 0
	PTR_FREE, self.pstrActions
	; self->closeWin
	OBJ_DESTROY, self.oSimul
END


PRO ClsSimulAcq::getValue, opt, val
	CASE opt OF
		'SimulObj': val = self.oSimul
		'DrawSize': val = self.iDrawSize
		'ChnXY': val = self.iChnXY
		'NumChnsCam': val = self.iNumChnCam
		'NumFrames': val = self.iNumFrames
		'ExposureTime': val = self.fExposureTime
		'DisplaySkip': val = self.iDisplaySkip
		'StrActions': val = *(self.pstrActions)
		'DisplayOptions': val = *(self.pstrDisplay)
		'DisplayInd': val = self.sDisplay
		'Delay': val = self.iDelay
		'MonitorStatus': val = self.sMonitor
		'AcquireStatus': val = self.sAcquire
		'Camera': val = self.sCamera 
		'CameraRange0': val = self.fRange[*,0]
		'CameraRange1': val = self.fRange[*,1]
    'CameraRange2': val = self.fRange[*,2]
    'Camera0Ind': val = self.iCamInd[0,*]
    'Camera1Ind': val = self.iCamInd[1,*]
    'Camera2Ind': val = self.iCamInd[2,*]
		'StrStimLogic0': self.oSimul->getValue, 'StrStimLogic', val
		; 'StrStimLogic1': self.oSimul->getValue, opt, val
		'StimAutoRed': val = self.sStimAutoRed
		'StimAutoRedStep': val = self.sStimAutoRedStep
		'AutoSave': val = self.sAutoSave
		'NumAuxChns': val = self.iNumAuxChns
		'AutoStimArr': val = self.sAutoStimArr
		'StrComments': val = self.strComments
		'BatchStatus': val = self.sBatch
		'FileTemplate': val = self.strFileTemplate
		'FileScanNum': val = self.iFileScanNum
    'StrInitializeRoutine': val = self.strInitializeRoutine
    'TraceInd': val = self.iTraceInd
    'MiddleFSD' : BEGIN
      self.oSimul->getValue, 'MiddleFSD', val
    END
    'MiddleSize':  self.oSimul->getValue, 'MiddleSize', val
    'gNaFactorCF' : self.oSimul->getValue, 'gNaFactorCF', val
	ENDCASE
END


PRO ClsSimulAcq::setValue, opt, val
	CASE opt OF
		'DataObj': self.oData = val
		'SimulObj': self.oSimul = val
		'Trigger': self.sTrigger = val
		'StimComments': BEGIN
		    self.sStimComments = val
		    self.oSimul->setValue, 'StimComments', val
		    END
		'StrAutoStim': self.strAutoStim = val
		'NumFrames': BEGIN
		    self.iNumFrames = val
		    self.oSimul->setValue, 'BuffSize', val
		    END
		'DisplaySkip': self.iDisplaySkip = val
		'Delay': self.iDelay = val
		'NumAuxChns': self.iNumAuxChns =  val 
		'NumChnsXY': self.iChnXY = val
		'wDrawTrace': self.wTrace = val
		'ExposureTime': BEGIN
			self.fExposureTime = val
			END
	  'Camera': BEGIN
	    self.sCamera = val
	    self.oMsg->addStr, 'Not ready yet'
	    END 
    'CameraRange0': BEGIN
        arr = STRSPLIT(val, ' ', /EXTRACT)
        self.fRange[*,0] = FLOAT(arr)
       END
    'CameraRange1': BEGIN
        arr = STRSPLIT(val, ' ', /EXTRACT)
        self.fRange[*,1] = FLOAT(arr)
       END
    'CameraRange2': BEGIN
        arr = STRSPLIT(val, ' ', /EXTRACT)
        self.fRange[*,2] = FLOAT(arr)
       END
		'Camera0Ind': BEGIN
        arr = STRSPLIT(val, ' ', /EXTRACT)
        self.iCamInd[0,*] = LONG(arr)
       END
    'Camera1Ind': BEGIN
        arr = STRSPLIT(val, ' ', /EXTRACT)
        self.iCamInd[1,*] = LONG(arr)
       END
    'Camera2Ind': BEGIN
        arr = STRSPLIT(val, ' ', /EXTRACT)
        self.iCamInd[2,*] = LONG(arr)
       END
    'wTop': self.wTop = val
		'wDrawStimulation': self.wDrawStimulation = val
		'wDrawId0': self.wDraw[0] = val
		'wDrawId1': self.wDraw[1] = val
		'wDrawId2': self.wDraw[2] = val
		'wFdCamera0': self.wFdCamera[0] = val
		'wFdCamera1': self.wFdCamera[1] = val
		'wFdCamera2': self.wFdCamera[2] = val
		'wFdFileScanNum': self.wFdFileScanNum = val
		'wFdTraceInd': self.wFdTraceInd = val
		'wMonitor': self.wMonitor = val
		'wWait': self.wWait = val
		'IsOpen': self.sIsOpen = val
		'DisplayOption': self.sDisplay = val
		'StrStimLogic0': BEGIN
		  self.oSimul->setValue, 'StimLogic', val
		  IF (self.sIsOpen) THEN BEGIN
		    self.oSimul->getValue, 'StimLogicArr', arr
		    winback = !D.WINDOW
		    WSET, self.wDrawStimulation
		    PLOT, arr, ystyle=5, xstyle=9
		    WSET, winback
		  ENDIF
			END
		'StrStimLogic1': BEGIN
			self.oStim->setValue, opt, val
			self.oStim->showStimLogic
			END
		'CaptureCheck': self.sCapture = val
		'wFdStimLogic': self.wFdStimLogic = val
		'IsOpen': self.sIsOpen = val
		'LightVoltage':self.oStim->setValue, opt, val
		'AutoSave': self.sAutoSave = val
		'StimAutoRed': self.sStimAutoRed = val
		'StimAutoRedStep': self.sStimAutoRedStep = val
		'wFdStrAutoStim': self.wStrAutoStim = val
		'AutoStimMax': self.sAutoStimArr[0] = val
		'AutoStimMin': self.sAutoStimArr[1] = val
		'StrComments': BEGIN
		    self.strComments = val
		    self.oSimul->setValue, 'Comments', val
		    END
		'wFdStrComments': self.wFdStrComments = val
		'BatchStatus': self.sBatch = val
		'wBatch': self.wBatch = val
		'StimAutoAdj': self.sStimAutoAdj = val
		'FilePath': self.strFilePath = val
		'FileTemplate': self.strFileTemplate = val
		'FileScanNum': self.iFileScanNum = val
		'StrInitializeRoutine': self.strInitializeRoutine = val
		'TraceInd': self.iTraceInd = val
		'SelectChnXY': BEGIN
     			 IF (val.type EQ 0) THEN BEGIN
       				 r = FLOAT(self.iChnXY) / FLOAT(self.iDrawSize)
       				 x=LONG(FLOAT(val.x) * r[0])
       				 y=self.iChnXY[1] - LONG(FLOAT(val.y) * r[1])
       				 self.iTraceInd = y * self.iChnXY[0] + x
        			 IF (self.sIsOpen) THEN BEGIN
           			 	WIDGET_CONTROL, self.wfdTraceInd, SET_VALUE=self.iTraceInd
           			 	self->showTrace
       				 ENDIF
				; info 
				self.oSimul->getCellInfo, self.iTraceInd, val
				self.oMsg->addStr, 'Celltype : ' + STRING(val[0])
				self.oMsg->addStr, 'Neighbors : ' + STRING(val[1]) + STRING(val[2]) + STRING(val[3])
     			 ENDIF
      			END
      			
     'MiddleFSD' : BEGIN
      self.oSimul->setValue, 'MiddleFSD', val 
     END
     'MiddleSize' : self.oSimul->setValue,'MiddleSize',val  			
     'gNaFactorCF' : self.oSimul->setValue, 'gNaFactorCF', val
	ENDCASE
END


PRO ClsSimulAcq::startMonitor
COMMON CM_SIMUL_ACQ
	self.sMonitor = 1
	;self.oSimul->setValue, 'FrameAt', 0
	self.oMsg->addStr, 'Monitor started'
	self->doMonitor
END

PRO ClsSimulAcq::doMonitor
	WIDGET_CONTROL, self.wMonitor, timer = 0.01
END


PRO ClsSimulAcq::stopMonitor
	self.sMonitor = 0
	self.oMsg->addStr, 'Monitor Stopped'
END


PRO ClsSimulAcq::advanceSimul
  CASE self.sStim OF
    0: self.oSimul->iterateN, self.iDisplaySkip
    1: self.oSimul->iterateStimN, self.iDisplaySkip
   ; 2: self.oSimul->iterateStimContN, self.iDisplaySkip
  ENDCASE
END


PRO ClsSimulAcq::showImage, img, range, drawwin, CamFLIP=CamFlip
	;camFlip = ['None', 'Horizontal', 'Vertical', 'Transpose']
	winback = !D.WINDOW
	WSET, drawwin
	
	opt = (*(self.pstrDisplay))[self.sDisplay]
	CASE opt OF
		'Norm':imgN = BYTSCL(img)
		'Range':imgN = BYTSCL(img, MIN=range[0], MAX=range[1])
	ENDCASE
	imgAdj = CONGRID(imgN, self.iDrawSize[0], self.iDrawSize[1])
	TV, imgAdj, /ORDER
	WSET, winback
END


PRO ClsSimulAcq::showCellTypes
  winback = !D.WINDOW
  WSET, self.wDraw[0]
  self.oSimul->getValue, 'CellTypes', cellTypes
  imgN = BYTSCL(cellTypes)
  imgAdj = CONGRID(imgN, self.iDrawSize[0], self.iDrawSize[1])
  TV, imgAdj, /ORDER
  WSET, winback
END


PRO ClsSimulAcq::showTrace
  winback = !D.WINDOW
  WSET, self.wTrace
  data = self.oSimul->getTrace(self.iTraceInd)
  opt = (*(self.pstrDisplay))[self.sDisplay]
  ; PLOT, data
  CASE opt OF
    'Norm': PLOT, data
    'Range': BEGIN
      yr = self.fRange[*,0]
      PLOT, data, yrange = yr ;imgN = BYTSCL(img, MIN=range[0], MAX=range[1])
    END
  ENDCASE
  WSET, winback
END



PRO ClsSimulAcq::saveTIFatomic, windraw, filetemp
	f = DIALOG_PICKFILE(FILE=filetemp, /WRITE, PATH=self.strFilePath)
	IF (f EQ '') THEN RETURN
	winback = !D.WINDOW
	WSET, windraw
	img = TVRD(/ORDER)
	WRITE_TIFF,  f, IMG
	WSET, winback
END


PRO ClsSimulAcq::saveTIF
	CASE self.sCamera OF
		0: self->saveTIFatomic, self.wDraw[0], 'monitor-camera0.tif'
		1: self->saveTIFatomic, self.wDraw[0], 'monitor-camera0.tif'
		2: BEGIN
			self->saveTIFatomic, self.wDraw[0], 'monitor-camera0.tif'
			self->saveTIFatomic, self.wDraw[1], 'monitor-camera1.tif'
			;self->saveTIFatomic, self.wDraw2
		   END
		3: BEGIN
			self->saveTIFatomic, self.wDraw[0], 'monitor-camera0.tif'
			self->saveTIFatomic, self.wDraw[1], 'monitor-camera1.tif'
			self->saveTIFatomic, self.wDraw[3], 'monitor-camera2.tif'
		  END
	ENDCASE
END


PRO ClsSimulAcq::showMonitor
COMMON CM_SIMUL_ACQ
  ;FOR I=0, self.iDisplaySkip-1 DO BEGIN
  ;    self.oSimul->iteration1ms
  ;ENDFOR
  self->advanceSimul
  ;CASE self.sStim OF
  ;  0: self.oSimul->iterateN, self.iDisplaySkip
  ;  1: self.oSimul->iterateStimN, self.iDisplaySkip
  ;  2: self.oSimul->iterateStimContN, self.iDisplaySkip
  ;ENDCASE
	images = self.oSimul->imagesFromBuffer()
	iNum = self.iChnXY[0]*self.iChnXY[1]
	FOR I=0L, self.sCamera-1 DO BEGIN
	   iStart = I*iNum
	   iEnd = iStart + iNum-1
	   fr = images[iStart:iEnd]
	   fr = REFORM(fr, self.iChnXY[0], self.iChnXY[1])
		self->showImage, fr, self.fRange[*,I], self.wDraw[I]
	END
	self->showTrace
END

; acquisition test

PRO ClsSimulAcq::startAcquire
COMMON CM_SIMUL_ACQ
  self.iDelayLeft = self.iDelay / self.iDisplaySkip
  self.iAcquireLeft = self.iNumFrames / self.iDisplaySkip
  self.sAcquire = 1
  self.oSimul->setBufferZero
  self.oMsg->addStr, 'Waiting acquisition'
  self->waitAcquisition
END


PRO ClsSimulAcq::waitAcquisition
  self->showMonitor
  self.iDelayLeft -= 1L
  IF (self.iDelayLeft EQ 0L) THEN BEGIN
    self.oSimul->setValue, 'FrameAt', 0
    self.oMsg->addStr, 'Acquisition started'
  END
  IF (self.iDelayLeft LT 0) THEN BEGIN
    self.iAcquireLeft -= 1
  END
  IF (self.sAcquire EQ 0) THEN BEGIN
    self.oMsg->addStr, 'Acqusition stopped'
  ENDIF
  IF (self.iAcquireLeft LE 0) THEN BEGIN
    self.sAcquire = 0 
		self.oMsg->addStr, 'Acquisition done. You can save the resutl using the SaveBuffer button ...'
		IF (self.sAutoSave) THEN self->writeFileAuto
		IF (self.sBatch GT 0) THEN self->idleBatch
	ENDIF
	IF (self.sAcquire) THEN BEGIN
    ; waiting
    WIDGET_CONTROL, self.wWait, timer = 0.1
  ENDIF
END



PRO ClsSimulAcq::abortAcquisition
	iValue = 0L
	self.sAcquire = 0
END

PRO ClsSimulAcq::startBatch
  ;IF (self.sStimAutoRed EQ 0) THEN BEGIN
  ;  self.oMsg->addStr, 'Please set auto reduction on'
  ;  return
  ;ENDIF
  ;self.oStim->getLastCL, sMax, beat
  ;self.oStim->setValue, 'SetCLDur', sMax * beat
  ;self.sBatch =  LONG((sMax - self.sAutoStimArr[1]) / self.sStimAutoRedStep)
  WIDGET_CONTROL, self.wBatch, timer = 0.1
  self.oMsg->addStr, 'Starting batch'
  ;self.oMsg->addStr, 'Estimated acq :' + STRING(self.sBatch)
END

PRO ClsSimulAcq::stopBatch
  self.sBatch = 0
END

PRO ClsSimulAcq::idleBatch
;  self->doAction, 'StimContAcq'
  ;IF (self.sCapture) THEN BEGIN
  ;    ; checking number of action potentials
  ;    calcNumberOfActionPotentials, numBeats
  ;    calcNumberOfActionPotentials, numBeatsStim, /STIM
  ;    IF (numBeats NE numBeatsStim) THEN BEGIN
  ;        self.oMsg->addStr, 'Stimulation pulse are not triggering action potentials'
  ;        self.sBatch = 0
  ;    ENDIF
  ;END
  IF (self.sBatch GT 0) THEN BEGIN
    self.sBatch -= 1
    self.oMsg->addStr, 'Remaining batch :' + STRING(self.sBatch)
    WIDGET_CONTROL, self.wBatch, timer = 0.1
  ENDIF
  IF (self.sBatch EQ 0) THEN self.oMsg->addStr, 'Batch ending ...'
END

PRO ClsSimulAcq::openWin
	IF (self.sIsOpen EQ 0) THEN	wCameraAcq, oWidData=self
END


PRO ClsSimulAcq::closeWin
 	IF (self.sIsOpen) THEN BEGIN
 		self.sIsOpen = 0
 		WIDGET_CONTROL, self.wTop, /DESTROY
 		OBJ_DESTROY, self
 	END
 	;self.oStim->ptrfreeStimLogic
END

; put the routines for new cells
; the routine should be something like this
; PRO makeLQT1Cells, o
;   o->getValue, 'SimulObj', oSimul
;   o->setValue, 'ArrDim', ....
PRO ClsSimulAcq::makeNewCells
; routine here

; and update the chnXY here
  self.oSimul->getValue, 'DimArr', val
  self.iChnXY = val[0:1]
  self.oSimul->getValue, 'BuffSize', buffsize
  self.iNumFrames = buffsize
  self.oSimul->getValue, 'StrStimLogic', strSTimLogic
  ; update display
  self.oMsg->addStr, 'Cells are configured. Ready to use now'
END

PRO ClsSimulAcq::writeFileAuto
  f = self.strFilePath + self.strFileTemplate + STRING(self.iFileScanNum, FORMAT='(I03)') + '.nc'
      ;f = DIALOG_PICKFILE(FILE=fname, /WRITE, filter='*.nc', $ 
      ;          PATH=self.strFilePath, GET_PATH=gpath)
      IF (f NE '') THEN BEGIN
        ;self.strFilePath = gpath
        self.oSimul->writeMultipleNetCDFs, f
        self.oMsg->addStr, 'Autosave button is on and the buffer has been saved'
        self.iFileScanNum += 1
        self->writeInfo, f
      ENDIF
      WIDGET_CONTROL, self.wFdFileScanNum, SET_VALUE=self.iFileScanNum
END

PRO ClsSimulAcq::writeInfo, datafilename
    infofilename = self.strFilePath + 'logsimul.txt'
    GET_LUN, fp
    OPENW, fp, infofilename, /APPEND
    PRINTF, fp, '--------------------'
    PRINTF, fp, FILE_BASENAME(datafilename)
    PRINTF, fp, self.strComments
    CLOSE, fp
    FREE_LUN, fp
END

PRO ClsSimulAcq::doAction, val, STRING=STRING
	IF (KEYWORD_SET(STRING)) THEN str = val ELSE str = (*(self.pstrActions))[val]
	;Print, val, str
	CASE str OF
		'Monitor': BEGIN
			self->startMonitor
			END
		'StopMonitor': BEGIN
			self->stopMonitor
			END
		'StimMonitor' : BEGIN
		  self.sStim = 1
		  self.oSimul->setValue, 'StimArrAt', 0L 
		  self->startMonitor
	   END	
		'LoadCells': BEGIN
		  f = DIALOG_PICKFILE(/READ, filter='*.nccell', $ 
		            PATH=self.strFilePath, GET_PATH=gpath)
		  IF (f NE '') THEN BEGIN
		    self.strFilePath = gpath
        self.oSimul->readCells, f
        self.oSimul->getValue, 'DimXY', val
        self.iChnXY = val[0:1]
        self.oSimul->makebuffer; setValue, 'BuffSize', self.iNumFrames
        
        self.oMsg->addStr, 'Cells are loaded'
      END
		  END
		'SaveCells': BEGIN
		  fname = self.strFileTemplate + STRING(self.iFileScanNum, FORMAT='(I03)') + '.nccell'
		  f = DIALOG_PICKFILE(FILE=fname, /WRITE, filter='*.nccell', $ 
                PATH=self.strFilePath, GET_PATH=gpath)
      IF (f NE '') THEN BEGIN
        self.strFilePath = gpath
        ;self.oMsg->addStr, 'Copying cells from cuda'
        self.oSimul->copyCellsToHost
        self.oMsg->addStr, 'Writing cells ..'
        self.oSimul->writeCells, f
        self.oMsg->addStr, 'Cells were saved'
      ENDIF
      END
		'TIF': self->saveTIF
		'ChangeCellValue': BEGIN
			;self.oSimul->changeCMCFStateConst
			self.oSimul->getvalue, 'gNaFactorCF', ff
			self.oSimul->updateINaCF, ff
			self.oMsg->addStr, 'Values were successfully updated'
			END
			
'ChangegNaFactor' :BEGIN
  ;self.oSimul->changeCMCFStateConst
  self.oSimul->getvalue, 'gNaFactorCF', ff
  self.oSimul->updateINaCF, ff
  self.oMsg->addStr, 'Values were successfully updated'
END

			
		'Acquire': BEGIN
			IF (self.sMonitor EQ 1) THEN self->stopMonitor
			self->startAcquire
			END
'StimAcquire': BEGIN
			 IF (self.sMonitor EQ 1) THEN self->stopMonitor
       ;self.oSimul->StimAcquire
			  
			  self.sStim = 1
			 ; self.oSimul->setValue, 'StimArrAt', 0L
			  self->startAcquire
		END
						
		'Abort': BEGIN
			self.sAcquire = 0
			self->stopBatch
      self->AbortAcquisition
      self.oMsg->addStr, 'Acquisition aborting'
			END
		'StartStim':BEGIN
			;self.oStim->sendStimLogic
			self.sStim = 1
			self.oSimul->setValue, 'StimArrAt', 0L
			self.oMsg->addStr, 'Stim started'
			END
		'StartStimCont': BEGIN
			self.sStim = 2
     	self.oSimul->setValue, 'StimArrAt', 0L
     	self.oMsg->addStr, 'StimCont started'
			END
		'StopStim': BEGIN
			self.sStim = 0
			self.oMsg->addStr, 'Stim stopped'
			END
		'StartBatch': BEGIN
		  	self->startBatch
		  	END
		'StopBatch': BEGIN
		 	 self->stopBatch
		 	 END
		'ShowCellTypes': BEGIN
		    self->showCellTypes
		    END
		'SaveBuffer': BEGIN
		  	fname = self.strFileTemplate + STRING(self.iFileScanNum, FORMAT='(I03)') + '.nc'
      			f = DIALOG_PICKFILE(FILE=fname, /WRITE, filter='*.nc', $ 
                		PATH=self.strFilePath, GET_PATH=gpath)
     		 	IF (f NE '') THEN BEGIN
        			self.strFilePath = gpath
        			self.oSimul->setValue, 'Comments', self.strComments
       				self.oSimul->writeMultipleNetCDFs, f, /savepathincluded
        			self.oMsg->addStr, 'Buffer saved'
        			self.iFileScanNum += 1
        			self->writeInfo, f
     			 ENDIF
      			WIDGET_CONTROL, self.wFdFileScanNum, SET_VALUE=self.iFileScanNum
     			END
		'UnloadDll': BEGIN
		  	self.oSimul->unloadCudaDll
		 	 END
		;'Light':self.oStim->Light
		'Close': self->closeWin
		'UpdateStructure' : BEGIN 
		  self->showCellTypes
		self.oSimul->setBufferZero
		    self.oSimul->updateCell3Dtube
		    self->showCellTypes
		    END
		

	END
END



PRO wCameraAcq_Event, Event

	WIDGET_CONTROL, Event.Id, GET_UVALUE=Ev
	WIDGET_CONTROL, Event.top, GET_UVALUE=oWidData

	; handle KILL requests
    IF TAG_NAMES(Event, /STRUCTURE_NAME) EQ 'WIDGET_KILL_REQUEST' THEN BEGIN
       oWidData->setValue, 'IsOpen', 0
       RETURN
    ENDIF

  	CASE Ev OF
  		'fdStimLogic': oWidData->setValue, 'StrStimLogic0', Event.Value
  		'fdStimLogic1': oWidData->setValue, 'StrStimLogic1', Event.Value
  		'bgTrigger':BEGIN
  			oWidData->setValue, 'Trigger', Event.Value
  			END
  		'bgStimComments': oWidData->setValue, 'StimComments', Event.Value
  		'bgGain': oWidData->setValue, 'CameraGain', Event.Value
		'bgMonitor': oWidData->action, Event.value
  		'fdExposureTime': oWidData->setValue, 'ExposureTime', Event.value
  		'fdDisplaySkip': oWidData->setValue, 'DisplaySkip', Event.value
  		'fdNumFrames': oWidData->setValue, 'NumFrames', Event.value
  		'lsNiDAQAuxChns': oWidData->setValue, 'NumNiDAQAuxChns', Event.Index
  		'lsFrames': oWidData->setValue, 'NumFramesInd', Event.Index
  		'lsGain0': oWidData->setValue, 'Gain0', Event.Index
  		'lsGain1': oWidData->setValue, 'Gain1', Event.Index
		'fdSampRate': oWidData->setValue, 'SRate', Event.value
		'bgCamera': oWidData->setValue, 'Camera', Event.value + 1
		'bgCameraFlip': oWidData->setValue, 'CameraFlip', Event.value
		'bgDisplay': oWidData->setValue, 'DisplayOption', Event.value
		'fdVpix': oWidData->setValue, 'Vpix', Event.value
		'bgActions': oWidData->doAction, Event.value
		'wMonitor': BEGIN
			oWidData->getValue, 'MonitorStatus', sMonitor
			IF (sMonitor) THEN BEGIN
				oWidData->showMonitor
				oWidData->doMonitor
			END
			END
		'wWait': BEGIN
			; WAIT, 0.5 ; wait 0.5 second
			oWidData->waitAcquisition
			END
  		'WRealTimeMovie': BEGIN
  	  		; timer function well known as idle function in other X windows widgets
	  		updateMovieWindowNow
	  		IF (aStcMovieOpt.sIdle) THEN WIDGET_CONTROL,aStcRTWidget.top, timer=0.01
  	  		END
  		'bsDRaw0': BEGIN ; idle for batch 
  	   		oWidData->doAction, 'StimContAcq', /STRING
  	  		END
		'fdLight': oWidData->setValue, 'LightVoltage', Event.Value
		'bgLight': oWidData->light, Event.Value
		'bgAutoSave': oWidData->setValue, 'AutoSave', Event.Value
		'bgStimAutoRed': oWidData->setValue, 'StimAutoRed', Event.Value
		'fdStimAutoRedStep': oWidData->setValue, 'StimAutoRedStep', Event.Value
		'fdAutoStimMax': oWidData->setValue, 'AutoStimMax', Event.Value
  		'fdAutoStimMin': oWidData->setValue, 'AutoStimMin', Event.Value
  		'fdStrComments': oWidData->setValue, 'StrComments', Event.Value
  		'bgStimAutoAdj': oWidData->setValue, 'StimAutoAdj', Event.Value
  		'bgCaptureCheck': oWidData->setValue, 'CaptureCheck', Event.Value
  		'fdCamera0': oWidData->setValue, 'Camera0Ind', Event.Value
    		'fdCamera1': oWidData->setValue, 'Camera1Ind', Event.Value
    		'fdCamera2': oWidData->setValue, 'Camera2Ind', Event.Value
    		'fdCamera0Range': oWidData->setValue, 'CameraRange0', Event.Value
    		'fdCamera1Range': oWidData->setValue, 'CameraRange1', Event.Value
    		'fdCamera2Range': oWidData->setValue, 'CameraRange2', Event.Value
    		'fdFileTemplate': oWidData->setValue, 'FileTemplate', Event.Value
    		'fdFileScanNum': oWidData->setValue, 'FileScanNum', Event.Value
    		'fdDelay': oWidData->setValue, 'Delay', Event.Value
    		'StrInitializeRoutine': oWidData->setValue, 'StrInitializeRoutine', Event.Value
    		'fdTraceInd': oWidData->setValue, 'TraceInd', Event.Value
    		'drCamera0': oWidData->setValue, 'SelectChnXY', Event
    		'fdMiddleFsd' : BEGIN 
    		    oWidData->setValue, 'MiddleFSD', Event.Value
    		    oWidData->getValue, 'MiddleFSD', val
    		    print, 'fsd was changed to   : ', val
    		    END
    		     
    		'fdMiddleSize' : BEGIN
    		    oWidData->setValue,  'MiddleSize', Event.Value
    		    oWidData->getValue,  'MiddleSize', val
    		    print, 'Middle CF size was changed to   : ', val
    		   
    		    END
        'fdgNaFactorCF' : BEGIN
          oWidData->setValue, 'gNaFactorCF', Event.Value
          END
          
   	 ENDCASE
END


; DO NOT REMOVE THIS COMMENT: END WMovie
; CODE MODIFICATIONS MADE BELOW THIS COMMENT WILL BE LOST.




PRO wCameraAcq, oWidData = oWidData, GROUP=Group

  	IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

  	junk   = { CW_PDMENU_S, flags:0, name:'' }

  	wCameraAcq_Top = WIDGET_BASE(GROUP_LEADER=Group, $
      						COLUMN=2, MAP=1, $
      						TITLE='Camera Control', $
      						TLB_KILL_REQUEST_EVENTS=1, $
      						UVALUE='wCameraAcq')
  	oWidData->setValue, 'wTop', wCameraAcq_Top

  	;btMonitor = WIDGET_BUTTON(wCameraAcq_Top, $
  	 ; 						VALUE='Monitor', XSIZE=20, $
  	 ; 						UVALUE='btMonitor')
  	;oWidData->setValue, 'BtMonitor', btMonitor
  	bsLeft = WIDGET_BASE(wCameraAcq_Top, $
                COLUMN=1, MAP=1, $
                UVALUE='bsLeft')
    bsRight = WIDGET_BASE(wCameraAcq_Top, $
                COLUMN=1, MAP=1, $
                UVALUE='bsRight')
                 
  	bsStimulation = WIDGET_BASE(bsLeft, $
  							COLUMN=1, MAP=1, $
  							UVALUE='bsStimulation')
	;Stimulation window
    wdrStimLogic = WIDGET_DRAW(bsStimulation, $
          RETAIN = 1, XSIZE=400, YSIZE = 100, $
          UVALUE='wDrStimLogic' )
  oWidData->setValue, 'wDrawStimulation', wDrStimLogic
	oWidData->getValue, 'StrStimLogic0', val
    fdStimLogic = CW_FIELD(bsStimulation, VALUE=val, $
          ROW = 1, STRING = 1, XSIZE=40,  $
          RETURN_EVENTS = 1, $
          TITLE='Stim logic 0:', $
          UVALUE='fdStimLogic')
    oWidData->setValue, 'wFdStimLogic', fdStimLogic
  

	bsCameraOption = WIDGET_BASE(bsRight, $
							COLUMN=1, MAP=1, $
							UVALUE='wWait')
	oWidData->setValue, 'wWait', bsCameraOption ; using idle widget

  t = ['Off', 'On']
    bgStimAutoRed = CW_BGROUP( bsCameraOption, t, $
              EXCLUSIVE = 1, ROW = 1, $
                LABEL_LEFT='CL Auto Reduction', $
                UVALUE='bgStimAutoRed')
                
                
   oWidData->getValue, 'StimAutoRedStep', val
  fdStimAutoRedStep = CW_FIELD(bsCameraOption, VALUE=val, $
          ROW =1, STRING = 1, XSIZE = 10, $
          RETURN_EVENTS=1, $
          TITLE='CL Reduction Step:', $
          UVALUE='fdStimAutoRedStep')
          
   t = ['Off', 'On']
   bgStimAutoAdj = CW_BGROUP( bsCameraOption, t, $
              EXCLUSIVE = 1, ROW = 1, $
                LABEL_LEFT='CL Auto Adjust', $
                UVALUE='bgStimAutoAdj')
          
   t = ['Off', 'On']
   bgCapture = CW_BGROUP( bsCameraOption, t, $
              EXCLUSIVE = 1, ROW = 1, $
                LABEL_LEFT='Capture Check', $
                UVALUE='bgCaptureCheck')
                       
                        
  oWidData->getValue, 'AutoStimArr', val
    ;fdAutoStimMax = CW_FIELD(bsCameraOption, VALUE=val[0], $
    ;      ROW = 1, INT = 1, XSIZE=10,  $
    ;      RETURN_EVENTS = 1, $
    ;      TITLE='Auto Stim Max: ', $
    ;      UVALUE='fdAutoStimMax')
    fdAutoStimMin = CW_FIELD(bsCameraOption, VALUE=val[1], $
          ROW = 1, INT = 1, XSIZE=10,  $
          RETURN_EVENTS = 1, $
          TITLE='Auto Stim Min: ', $
          UVALUE='fdAutoStimMin')
    
 
   	; misc options
  t = ['Off', 'On']
    bgStimComments = CW_BGROUP( bsCameraOption, t, $
                EXCLUSIVE = 1, ROW = 1, $
                LABEL_LEFT='Stim to Comments?', $
                UVALUE='bgStimComments')
                
    oWidData->getValue, 'ExposureTime', fExposure
  	fdExposureTime = CW_FIELD( bsCameraOption, VALUE=fExposure, $
      						ROW=1, FLOAT=1, XSIZE = 10, $
      						RETURN_EVENTS=1, $
      						TITLE='Exposure (ms)   ', $
      						UVALUE='fdExposureTime')

	oWidData->getValue, 'DisplaySkip', iSkip
    fdSkip = CW_FIELD( bsCameraOption, VALUE=iSkip, $
                  ROW=1, FLOAT=1, XSIZE = 10, $
                  RETURN_EVENTS=1, $
                  TITLE='Display Skip   ', $
                  UVALUE='fdDisplaySkip')

	
  oWidData->getValue, 'NumFrames', NumFrames
    fdFrames = CW_FIELD( bsCameraOption, VALUE=NumFrames, $
                  ROW=1, LONG=1, XSIZE = 10, $
                  RETURN_EVENTS=1, $
                  TITLE='NumFrames   ', $
                  UVALUE='fdNumFrames')
  
  oWidData->getValue, 'Delay', iDelay
    fdDelay = CW_FIELD( bsCameraOption, VALUE=iDelay, $
                  ROW=1, INT=1, XSIZE = 10, $
                  RETURN_EVENTS=1, $
                  TITLE='Delay   ', $
                  UVALUE='fdDelay')
  
  oWidData->getValue, 'TraceInd', iVal
    fdTraceInd = CW_FIELD( bsCameraOption, VALUE=iVal, $
                  ROW=1, INT=1, XSIZE = 10, $
                  RETURN_EVENTS=1, $
                  TITLE='Trace Chn# ', $
                  UVALUE='fdTraceInd')
   oWidData->setValue, 'wFdTraceInd', fdTraceInd
  
  oWidData->getValue, 'FileTemplate', iVal
    fdFileTemplate = CW_FIELD( bsCameraOption, VALUE=iVal, $
                  ROW=1, STRING=1, XSIZE = 10, $
                  RETURN_EVENTS=1, $
                  TITLE='FileTemplate   ', $
                  UVALUE='fdFileTemplate')
  
  oWidData->getValue, 'FileScanNum', iVal
    fdFileScanNum = CW_FIELD( bsCameraOption, VALUE=iVal, $
                  ROW=1, INT=1, XSIZE = 10, $
                  RETURN_EVENTS=1, $
                  TITLE='ScanNum   ', $
                  UVALUE='fdFileScanNum')
  oWidData->setValue, 'wFdFileScanNum', fdFileScanNum
	; misc options
	t = ['Off', 'On']
  	bgTrigger = CW_BGROUP( bsCameraOption, t, $
  							EXCLUSIVE = 1, ROW = 1, $
    						LABEL_LEFT='Trigger', $
    						UVALUE='bgTrigger')

  t = ['off', 'on']
  bgAutoSave = CW_BGROUP( bsCameraOption, t, $
              EXCLUSIVE = 1, ROW = 1, $
                LABEL_LEFT='AutoSave', $
                UVALUE='bgAutoSave')
                
  ;fd setting part
 ; fdlabelCF = WIDGET_LABEL( bsCameraOption, VALUE=' ', /ALIGN_CENTER)
  fdlabelCF = WIDGET_LABEL( bsCameraOption, VALUE='Simulation Paramter Setting', /ALIGN_CENTER,  YOFFSET=1.0 )
;  fdlabelCF = WIDGET_LABEL( bsCameraOption, VALUE='  ', /ALIGN_CENTER)
  
  oWidData->getValue, 'MiddleFSD', mfsd
  fdMiddleFsd = CW_FIELD( bsCameraOption, VALUE=mfsd, $
    ROW=1, LONG=1, XSIZE = 10, $
    RETURN_EVENTS=1, $
    TITLE='CF fSD   ', $
    UVALUE='fdMiddleFsd')              
  
  oWidData->getValue, 'MiddleSize', mCFs          
  fdMiddleSize = CW_FIELD( bsCameraOption, VALUE=mCFs, $
    ROW=1, LONG=1, XSIZE = 10, $
    RETURN_EVENTS=1, $
    TITLE='Middle CF size   ', $
    UVALUE='fdMiddleSize')
                   
  oWidData->getValue, 'gNaFactorCF', gNaFactor
  fdgNaFactorCF = CW_FIELD( bsCameraOption, VALUE=gNaFactor, $
    ROW=1, XSIZE = 10, $
    RETURN_EVENTS=1, $
    TITLE='gNa multiply Factor   ', $
    UVALUE='fdgNaFactorCF')
    
    
                   
;	cam = ['1', '2', '3']
;	oWidData->getValue, 'Camera', iVal
;	bgCamera = CW_BGROUP( bsCameraOption, cam, $
;  							EXCLUSIVE = 1, ROW = 1, $
;    						LABEL_LEFT='Camera', $
;    						SET_VALUE = iVal - 1, $
;    						UVALUE='bgCamera')

	;camFlip = ['None', 'Horizontal', 'Vertical', 'Transpose']
	;bgCameraFlip = CW_BGROUP( wCameraAcq_Top, camFlip, $
  	;						EXCLUSIVE = 1, ROW = 1, $
    ;						LABEL_LEFT='Camera1 Flip', $
    ;						UVALUE='bgCameraFlip')

	oWidData->getValue, 'DisplayOptions', str
	bgDisplay = CW_BGROUP( bsLeft, str, $
							EXCLUSIVE=1, ROW=1, $
							LABEL_LEFT='Display Option', $
							UVALUE='bgDisplay')

    ; two camera draw widgets
 	bsDraw = WIDGET_BASE(bsLeft, $
      						ROW=1, MAP=1, $
      						UVALUE='wMonitor')
	oWidData->setValue, 'wMonitor', bsDraw
	bsDraw0 = WIDGET_BASE(bsDraw, COLUMN=1, MAP=1, UVALUE='bsDRaw0')
	oWidData->setValue, 'wBatch', bsDraw0 ; use baDraw0 for idle Batch
;	bsDraw1 = WIDGET_BASE(bsDraw, COLUMN=1, MAP=1, UVALUE='bsDRaw1')
;	bsDraw2 = WIDGET_BASE(bsDraw, COLUMN=1, MAP=1, UVALUE='bsDRaw2')

	oWidData->getValue, 'DrawSize', dsize
	
	drCamera0 = WIDGET_DRAW( bsDraw0, $
      						RETAIN=1, $
      						XSIZE = dsize[0], YSIZE = dsize[1], $
      						BUTTON_EVENTS = 1, $
      						UVALUE='drCamera0')
  oWidData->getValue, 'Camera0Ind', iVal
	fdCamera0 = CW_FIELD( bsDraw0, VALUE=STRING(iVal), $
  							ROW=1, XSIZE=20, $
							TITLE='Camera 0', $
							RETURN_EVENTS=1, $
							STRING=1, $
  							UVALUE='fdCamera0')
	;oWidData->setValue, 'wFdCamera0', fdCamera0
  oWidData->getValue, 'CameraRange0', iRange
  fdCamera0Range = CW_FIELD( bsDraw0, VALUE=STRING(iRange), $
                ROW=1, XSIZE=20, $
              TITLE='Range 0', $
              RETURN_EVENTS=1, $
              STRING=1, $
                UVALUE='fdCamera0Range')
  ; oWidData->setValue, 'wFdCamera0Range', fdCamera0
	
;	drCamera1 = WIDGET_DRAW( bsDraw1, $
;      						RETAIN=1, $
;      						XSIZE = dsize[0], YSIZE = dsize[1], $
;                  UVALUE='drCamera1')
;	oWidData->getValue, 'Camera1Ind', iVal
;  fdCamera1 = CW_FIELD( bsDraw1, VALUE=STRING(iVal), $
;  							ROW=1, XSIZE=20, $
;                RETURN_EVENTS=1, $
;                TITLE='Camera 1', $
;  							STRING=1, $
;                UVALUE='fdCamera1')
;  oWidData->getValue, 'CameraRange1', iRange
;  fdCamera0Range = CW_FIELD( bsDraw1, VALUE=STRING(iRange), $
;                ROW=1, XSIZE=20, $
;              TITLE='Range 1', $
;              RETURN_EVENTS=1, $
;              STRING=1, $
;                UVALUE='fdCamera1Range')	;oWidData->setValue, 'wFdCamera1', fdCamera1

;	drCamera2 = WIDGET_DRAW( bsDraw2, $
;      						RETAIN=1, $
;      						XSIZE = dsize[0], YSIZE = dsize[1], $
;							UVALUE='drCamera2')
;  oWidData->getValue, 'Camera2Ind', iVal
;  fdCamera2 = CW_FIELD( bsDraw2, VALUE=STRING(iVal), $
;  							ROW=1, XSIZE=20, $
;                RETURN_EVENTS=1, $
;                TITLE='Camera 2', $
;  							STRING=1, $
;                UVALUE='fdCamera2')
;	;oWidData->setValue, 'wFdCamera2', fdCamera2
;  oWidData->getValue, 'CameraRange2', iRange
;  fdCamera0Range = CW_FIELD( bsDraw2, VALUE=STRING(iRange), $
;                ROW=1, XSIZE=20, $
;              TITLE='Range 2', $
;              RETURN_EVENTS=1, $
;              STRING=1, $
;                UVALUE='fdCamera2Range')
                
   ;Trace window
    wdrTrace = WIDGET_DRAW(bsLeft, $
          RETAIN = 1, XSIZE=700, YSIZE = 150, $
          UVALUE='wDrTrace' )
   
	TextVal212 = [ $
    		'Msg' ]
	txtMsg = WIDGET_TEXT( bsLeft,VALUE=TextVal212, $
						UVALUE='txtMsg', $
						XSIZE=30, $
						YSIZE=5)
	oWidData->initMsgBox, txtMsg, 5
  
  oWidData->getValue, 'StrComments', val
  fdStrComments = CW_FIELD(bsLeft, VALUE=val, $
          ROW = 1, STRING = 1, XSIZE=80,  $
          ALL_EVENTS = 1, $
          TITLE='Add Comments', $
          UVALUE='fdStrComments')
  oWidData->setValue, 'wFdStrComments', fdStrComments
  
  oWidData->getValue, 'StrInitializeRoutine', val
  fdStrInitializeRoutine = CW_FIELD(bsLeft, VALUE=val, $
          ROW = 1, STRING = 1, XSIZE=80,  $
          RETURN_EVENTS = 1, $
          TITLE='Initialize Routine', $
          UVALUE='fdStrInitializeRoutine')
  
  
	oWidData->getValue, 'StrActions', strActions
 	bgActions = CW_BGROUP( bsLeft, strActions, $
  							ROW = 2, UVALUE='bgActions')
	

  	WIDGET_CONTROL, wCameraAcq_Top, /REALIZE
  	oWidData->setValue, 'IsOpen', 1
  	WIDGET_CONTROL, wdrStimLogic, GET_VALUE=drWidStim
  	oWidData->setValue, 'wDrawStimulation', drWidStim
  	WIDGET_CONTROL, drCamera0, GET_VALUE=drWid0
	oWidData->setValue, 'wDrawId0', drWid0
;	WIDGET_CONTROL, drCamera1, GET_VALUE=drWid1
;	oWidData->setValue, 'wDrawId1', drWid1
;	WIDGET_CONTROL, drCamera2, GET_VALUE=drWid2
;	oWidData->setValue, 'wDrawId2', drWid2
  WIDGET_CONTROL, wdrTrace, GET_VALUE=drTrace
  oWidData->setValue, 'wDrawTrace', drTrace
	WIDGET_CONTROL, wCameraAcq_Top, SET_UVALUE=oWidData
  	XMANAGER, 'wCameraAcq', wCameraAcq_Top, /NO_BLOCK
END


