
/* Modified for multicellcular version 
   using struct
   can be called from an iterpreter languages
   use cuda approach to accelerate calculation
   GNU public license
   Copyright to Bum-Rak Choi
   Oct 3, 2012 */

 
#ifndef STCCELL_CUDA_INTERFACE_H
#define STCCELL_CUDA_INTERFACE_H

#ifdef __cplusplus 
	extern "C" {
#endif

#include "StcCell.h"
#include "StcCell_Container.h"
#include "StcCell_Diffusion.h"

#define iCudaBlockSize 32 // default value, can be reset with IDL_set_Cuda_BlockSize

/* List of variables and paramaters */ 
#define PI 3.1415926535897932846264

/* interface */
int cuda_set_DeviceId (int );
void cuda_meminfo(size_t *, size_t *);
void cuda_set_BlockSize(int );
void cuda_set_dt (TypeCellML );

void cuda_get_info_ctn(int *);
void cuda_get_info_cell(int , int *);
void cuda_get_info_diffusion(int *);

void cuda_alloc_ctn(void);
void cuda_free_ctn(void);
void cuda_alloc_diffusion(int );
void cuda_free_diffusion(void);

void cuda_add_cell(enum CellType , int );
void cuda_set_CellValue(int, TypeCellML *, int , enum CellMLVarType);
void cuda_get_CellValue(int, TypeCellML *, int , enum CellMLVarType);

void cuda_get_CellLoc(int , int *);
void cuda_set_CellLoc(int , int *);

void cuda_get_Cell_State(int , TypeCellML *);
void cuda_get_Cell_Const(int , TypeCellML *);
void cuda_set_Cell_State(int , TypeCellML *);
void cuda_set_Cell_Const(int , TypeCellML *);

void cuda_get_ValueSorted(TypeCellML *pVal, int *, enum CellMLVarType );
void cuda_get_Vm (TypeCellML *);
void cuda_set_Vm (TypeCellML *);
void cuda_set_stim(TypeCellML *);

void cuda_set_DiffParm(int *, TypeCellML *);
void cuda_simulate_SingleStep (void);
void cuda_simulate_Nsteps (int);
void cuda_simulate_NstepsNoDiffusion (int );
void cuda_calc_Diffusion(void);

#ifdef __cplusplus
}
#endif

#endif

