
 
#ifndef StcCellDiffusion_H
#define StcCellDiffusion_H

#ifdef __cplusplus 
	extern "C" {
#endif


#include "StcCell.h"
#include "StcCell_Container.h"


typedef struct {
	StcCellContainer *pCtn;
	int iNCell;
	int iNCoupling;
	int isAllocated;
	int *d_NeighborInd;
	// int *d_CellFlag;
	TypeCellML *d_DiffCoeff;
	TypeCellML *d_diff;
	TypeCellML *d_Vm;
} StcCellDiffusion ;


void diff_alloc_StcCellDiffusion(StcCellDiffusion *);
StcCellDiffusion *diff_prototype_StcCellDiffusion(StcCellContainer *, int iMaxCoupling);
void diff_free_StcCellDiffusion(StcCellDiffusion *);
void diff_set_DiffParm(StcCellDiffusion *, int *, TypeCellML *); 
void diff_get_VmFromCell(StcCellDiffusion *);
void diff_calc_Diffusion(StcCellDiffusion *);
void diff_put_DiffOnCell(StcCellDiffusion *);



#ifdef __cplusplus
}
#endif

#endif

