

FUNCTION getStimInfo, aStr
	s = LONARR(5)
	strS = STR_SEP(aStr, 'S')
	strDot = STR_SEP(strS[1], '.')
	s[0] = 1
	s[1] = LONG(strDot[0]) ; Num of Beats
	S[2] = LONG(strDot[1]) ; interval time
	S[3] = LONG(strDot[2]) ; duration of pulse
	s[4] = s[1] * s[2]
	RETURN, s
END


FUNCTION getRandomInfo, aStr
	r = LONARR(5)
	str_r = STR_SEP(aStr, 'R')
	str   = STR_SEP(str_r[1], '.')
	r[0]  = 0
	r[1]  = LONG(str[0]) ;Min
	r[2]  = LONG(str[1]) ;Max
	r[3]  = LONG(str[2]) ;duration
	r[4]  = LONG(str[3]) ;Total Time
	RETURN, r
END


FUNCTION makeStimArr, stimLogic
	timeTotal = LONG(stimLogic[4] + stimLogic[3])
	arrStim = INTARR(timeTotal)
	ind = 0
	FOR J = 0, stimLogic[1] - 1 DO BEGIN
			ind = ind + stimLogic[2]
			arrStim[ind:(ind+stimLogic[3]-1)] = 1
	END
	; arrStim = SHIFT(arrStim, -stimLogic[3])
	RETURN, arrStim[stimLogic[3]:*] ; [0L:timeTotal-1L]
END


FUNCTION makeRandomStimLogic, r
	timeTotal = RANDOMU(seed, r[4]/r[1]) ;make random array
	vector = timeTotal * (r[2] - r[1]) + r[1] ;Maps to min and max values
	tt = vector[0]
	randomarr = vector[0]
	I = 1
	WHILE (tt LE r[4]) DO  BEGIN
	; 1, tt LE r[2] DO BEGIN
		randomarr = [randomarr, vector[I]]
		tt = tt + vector[I]
		i = i + 1
    END
	random_int = LONG(randomarr)
	RETURN, random_int

END


FUNCTION makeRandomArr, random_int, stimLogic
	timeTotal = LONG(TOTAL(random_int))
	aTempArr = INTARR(timeTotal+stimLogic[3])
	numStim = N_ELEMENTS(random_int)
	ind = 0L
	dur = stimLogic[3] - 1
	FOR I=0L, numStim - 1L DO BEGIN
		ind = ind + random_int[I]
		aTempArr[ind:(ind+dur)] = 1
	END
	;print, random_int
	RETURN, aTempArr
END


FUNCTION getOscillationInfo, aStr
	o = LONARR(6)
	str_r = STR_SEP(aStr, 'O')
	str   = STR_SEP(str_r[1], '.')
	o[0] = 2 ; type index
	o[1] = LONG(str[0]) ; number of oscillation
	o[2] = LONG(str[1]) ; center
	o[3] = LONG(str[2]) ; delta
	o[4] = LONG(str[3]) ; duration
	o[5] = o[1] * o[2] * 2 ; total time
	RETURN, o
END



FUNCTION makeOscillationArr, stimLogic
	timeTotal = LONG(TOTAL(stimLogic[5]) + stimLogic[4])
	arrStim = INTARR(timeTotal)
	s1 = stimLogic[2] - stimLogic[3]
	s2 = stimLogic[2] + stimLogic[3]
	dur = stimLogic[4]
	ind = 0L
	FOR J = 0, stimLogic[1] - 1 DO BEGIN
			ind = ind + s1
			arrStim[ind:(ind+dur-1)] = 1
			ind = ind + s2
			arrStim[ind:(ind+dur-1)] = 1
	END
	RETURN, arrStim
END


FUNCTION getHistStimInfo, aStr
	o = LONARR(6)
	str_r = STR_SEP(aStr, 'H')
	str   = STR_SEP(str_r[1], '.')
	o[0] = 3 ; type index
	o[1] = LONG(str[0]) ; Start
	o[2] = LONG(str[1]) ; End
	o[3] = LONG(str[2]) ; step
	o[4] = LONG(str[3]) ; duration
	;o[5] = o[1] * o[2] * 2 ; total time
	RETURN, o
END



FUNCTION makeHistStimArr, stimLogic
	num = FIX((stimLogic[2] - stimLogic[1]) / stimLogic[3])
	indstim = INDGEN(ABS(num)+1) *  stimLogic[3] * ABS(num) / num + stimLogic[1]
	timeTotal = LONG(TOTAL(indstim) + stimLogic[4])
	arrStim = INTARR(timeTotal)
	dur = stimLogic[4]
	ind = 0L
	FOR J = 0, N_ELEMENTS(indstim)-1 DO BEGIN
			ind = ind + indstim[J]
			arrStim[ind:(ind+dur-1)] = 1
	END
	RETURN, arrStim
END


